#ifndef CLASSEXT_H
#define CLASSEXT_H

// defined in classext.cpp ---------------------------------------------------

class dbCObArray : public CObArray
{
public:
	dbCObArray();
	virtual ~dbCObArray();
	int IsEmpty();
	void Empty();
	void SetIndex(int index);
	int GetIndex();
	CObject *GetFirst();
	CObject *GetNext();
	CObject *GetLast();
	CObject *GetPrior();
	int Find(CObject *cmp);
	void Sort(int (__cdecl *cmp)(const void *, const void *), int invert = 0);
	BOOL IsAtFirst() {if (IsEmpty()) return FALSE; if (p_index) return FALSE; return TRUE;};
	BOOL IsAtLast() {if (IsEmpty()) return FALSE; if (p_index == GetUpperBound()) return TRUE; return FALSE;};
	void SetAutoDelete(BOOL sw = TRUE);
private:
	int p_index;
	BOOL p_autodelete;
};

// include this macro in your derived class to typedef the returns
//	Parm O is the class that is stored....

#define DEVTYPE(O) \
	O *GetFirst() {return (O *)dbCObArray::GetFirst(); }; \
	O *GetNext() {return (O *)dbCObArray::GetNext(); }; \
	O *GetLast() {return (O *)dbCObArray::GetLast(); }; \
	O *GetPrior() {return (O *)dbCObArray::GetPrior(); }; \
	O *GetAt(int Index) {return (O *)dbCObArray::GetAt(Index); }; 


template <class O> class DBCOBARRAY : public dbCObArray {
	public:
		DBCOBARRAY() {}
		virtual ~DBCOBARRAY() {}
 	O *GetFirst() {return (O *)dbCObArray::GetFirst(); };
	O *GetNext() {return (O *)dbCObArray::GetNext(); };
	O *GetLast() {return (O *)dbCObArray::GetLast(); };
	O *GetPrior() {return (O *)dbCObArray::GetPrior(); };
	O *GetAt(int Index) {return (O *)dbCObArray::GetAt(Index); };
	void InsertAt(int Index, O *In, int Count = 1) {dbCObArray::InsertAt(Index, In, Count);};
	void Add(O *In) {dbCObArray::Add(In);};
};

/*
Usage:

DBCOBARRAY<MyClass> MyClassArray;

Constructs a dbCObArray derived object that stores only MyClass objects.
*/

/* three useful macros that perform F (a macro you provide) 
		on every element(class C) 
		in dclxCObArray A
	use CAP_ITERATE if the A is a pointer, CA_ITERATE if not
	or CAD_ITERATE in your derived class

example:
	#define FUNC c->DoSomething()
	DCLXCOBARRAY<myCObject> a;
	CA_ITERATE(a, myCObject, FUNC);
*/

#define CA_ITERATE(A, C, F) { C *c = A.GetFirst(); while (c) {F; c = A.GetNext();	}}
#define CAP_ITERATE(A, C, F) { C *c = A->GetFirst(); while (c) {F; c = A->GetNext();	}}
#define CAD_ITERATE(C, F) { C *c = GetFirst(); while (c) {F; c = GetNext(); }}


#endif

