#ifndef DELTA_H
#define DELTA_H

struct deltacontrol {
	int current;
	int delta;
	int len;
	int togo;
};

class DeltaControl
{
public:
	DeltaControl();
	virtual void SetFrom(int Major, int Minor);
	virtual void SetTo(int Major, int Minor);
	virtual BOOL Next();
	int GetMajor() {return m_Major.current;};
	int GetMinor() {return m_Minor.current;};
	virtual int GetLength() {return m_Minor.len + m_Major.len;};
protected:
	virtual void OnMajorChange(int Current) {};
	virtual void OnMinorChange(int Current) {};
	deltacontrol m_Major;
	deltacontrol m_Minor;
	int m_ErrorTerm;
	virtual void SetTo(int In, deltacontrol *Out);
	BOOL m_MinorLast;
};

class DeltaControlLine : public DeltaControl, public CPoint
{
public:
	DeltaControlLine(CPoint *From, CPoint *To);
	DeltaControlLine(CPoint *From, CPoint *To, CPoint *Offset);
	virtual ~DeltaControlLine() {};
protected:
	virtual void Init(CPoint *From, CPoint *To);
	virtual void OnMajorChange(int Current) {*m_PMajor = Current;};
	virtual void OnMinorChange(int Current) {*m_PMinor = Current;};
	long *m_PMajor;
	long *m_PMinor;
};

class DeltaControlPair : public DeltaControl
{
public:
	DeltaControlPair(DeltaControl *A, DeltaControl *B);
	virtual ~DeltaControlPair() {};
	virtual int GetLength() {return m_Major.len;};
	virtual BOOL Next();
protected:
	virtual void OnMajorChange(int Current) {m_PMajor->Next();};
	virtual void OnMinorChange(int Current) {m_PMinor->Next();};
	DeltaControl *m_PMajor;
	DeltaControl *m_PMinor;
};

#endif
