// DestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "newtrick.h"
#include "DestDlg.h"
#include "image.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// indexes into the m_Corner array
#define TOPLEFT 0
#define TOPRIGHT 1
#define BOTTOMLEFT 3
#define BOTTOMRIGHT 2

/////////////////////////////////////////////////////////////////////////////
// CDestDlg dialog

CDestDlg::CDestDlg(CImageBitmap *Image, CImageBitmap *Source,   // ) {
		CWnd* pParent /*=NULL*/) : CDialog(CDestDlg::IDD, pParent) {
	//{{AFX_DATA_INIT(CDestDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_Bitmap = Image;
	m_Active = 0;
	int i = 0;
	BITMAP *b = *Source;
	m_Corner[TOPLEFT].Create(0, 0, TOPLEFT);
	m_Corner[TOPRIGHT].Create(b->bmWidth, 0, TOPRIGHT);
	m_Corner[BOTTOMLEFT].Create(0, b->bmHeight, BOTTOMLEFT);
	m_Corner[BOTTOMRIGHT].Create(b->bmWidth, b->bmHeight, BOTTOMRIGHT);
	m_Source = Source;
	m_ShowLines = TRUE;
	Create(CDestDlg::IDD, pParent);
	const char *c = *Image;
	if (c) SetWindowText(c);
}

CDestDlg::~CDestDlg() {
	if (m_Bitmap) delete m_Bitmap;
	m_Bitmap = 0;
}

void CDestDlg::DoDataExchange(CDataExchange* pDX) {
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDestDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDestDlg, CDialog)
	//{{AFX_MSG_MAP(CDestDlg)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_PAINT()
	ON_WM_SIZE()
	ON_WM_MOUSEMOVE()
	ON_WM_CLOSE()
	ON_WM_HSCROLL()
	ON_WM_VSCROLL()
	ON_WM_LBUTTONDBLCLK()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDestDlg message handlers

void CDestDlg::OnClose() {
	if (m_Bitmap) delete m_Bitmap;
	m_Bitmap = 0;
	CDialog::OnClose();
}

BOOL CDestDlg::OnInitDialog() {
	CDialog::OnInitDialog();
	CRect r;
	GetClientRect(r);
	SetSize(r.Width(), r.Height());
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDestDlg::OnLButtonDown(UINT nFlags, CPoint point){
	int i;

	if (!m_ShowLines) {
		m_ShowLines = TRUE;
		Invalidate();
	}
	for (i = 0, m_Active = 0; i < 4 && !m_Active; i++) {
		if (m_Corner[i].PtInRect(point)) m_Active = &m_Corner[i];
	}
	if (m_Active) {
		m_Offset = *m_Active;
		m_Offset -= point;
	}
	CDialog::OnLButtonDown(nFlags, point);
}

void CDestDlg::OnLButtonUp(UINT nFlags, CPoint point) {
	m_Active = 0;
	CDialog::OnLButtonUp(nFlags, point);
}

void CDestDlg::OnPaint() {
	CPaintDC dc(this); // device context for painting
	if (!m_Bitmap) return;
	if (!m_Bitmap->BMPLoaded()) return;
	if (m_Bitmap->CreationRequired()) {
		if (!m_Bitmap->CreateFromBMPFile(&dc)) return;
	}
	CSize *s = *m_Bitmap;
	if (!s) return;
	CDC d;
	d.CreateCompatibleDC(&dc);
	CBitmap *b = d.SelectObject(m_Bitmap);
	CRect r;
	GetClientRect(r);
	int cx = min(s->cx, r.Width());
	int cy = min(s->cy, r.Height());
	int x = max(GetScrollPos(SB_HORZ), 0);
	int y = max(GetScrollPos(SB_VERT), 0);
	dc.BitBlt(0, 0, cx, cy, &d, x, y, SRCCOPY);
	d.SelectObject(b);
	int i, j = dc.SetROP2(R2_XORPEN);
	for (i = 0; i < 4 && m_ShowLines; i++) m_Corner[i].DrawIcon(&dc);
	CGdiObject *p = dc.SelectStockObject(WHITE_PEN);
	dc.MoveTo(m_Corner[3]);
	for (i = 0; i < 4 && m_ShowLines; i++) dc.LineTo(m_Corner[i]);
	dc.SetROP2(j);
	dc.SelectObject(p);
}

void CDestDlg::OnSize(UINT nType, int cx, int cy) {
	CDialog::OnSize(nType, cx, cy);
	SetSize(cx, cy);
}

void CDestDlg::OnLButtonDblClk(UINT nFlags, CPoint point) {
	if (m_ShowLines) Transform();
	CDialog::OnLButtonDblClk(nFlags, point);
}

void CDestDlg::SetSize(int cx, int cy) {
	if (!m_Bitmap) return;
	if (!m_Bitmap->BMPLoaded()) return;
	CSize *s = *m_Bitmap;
	if (!s) return;
	int x = s->cx - cx;
	int y = s->cy - cy;
	if (x < 1) ShowScrollBar(SB_HORZ, FALSE);
	else {
		ShowScrollBar(SB_HORZ, TRUE);
		SetScrollRange(SB_HORZ, 0, x);
	}
	if (y < 1) ShowScrollBar(SB_VERT, FALSE);
	else {
		ShowScrollBar(SB_VERT, TRUE);
		SetScrollRange(SB_VERT, 0, y);
	}
}

void CDestDlg::OnMouseMove(UINT nFlags, CPoint point) {
	if ((nFlags & MK_LBUTTON) && m_Active) {
		m_Active->AdjustAOI(&point, &m_Offset);
		Invalidate();
	}
	CDialog::OnMouseMove(nFlags, point);
}


void CDestDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) {
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
	if (nSBCode != SB_THUMBTRACK) return;
	SetScrollPos(SB_HORZ, nPos);
	Invalidate();
}

void CDestDlg::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) {
	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
	if (nSBCode != SB_THUMBTRACK) return;
	SetScrollPos(SB_VERT, nPos);
	Invalidate();
}

void CDestDlg::Transform(CImageBitmap *In) {
	if (!m_Bitmap) return;
	if (!In) In = m_Source;
	CPoint p;
	p.x = max(GetScrollPos(SB_HORZ), 0);
	p.y = max(GetScrollPos(SB_VERT), 0);
	m_Bitmap->Transform(In, &m_Corner[TOPLEFT], &m_Corner[BOTTOMLEFT],
			&m_Corner[TOPRIGHT], &m_Corner[BOTTOMRIGHT], &p);
	m_ShowLines = FALSE;
	Invalidate();
}

CDestCorner::CDestCorner() {}
CDestCorner::~CDestCorner() {}

void CDestCorner::Create(int X, int Y, int Index) {
	switch (Index) {
		case TOPLEFT:
			m_Offset.left = m_Offset.top = 0;
			m_Offset.bottom = m_Offset.right = 16;
			m_Icon = theApp.LoadIcon(IDI_UPPERLEFT);
			m_HotSpot[1].x = m_HotSpot[1].y = 0;
			break;
		case TOPRIGHT:
			m_Offset.right = m_Offset.top = 0;
			m_Offset.bottom = 16;
			m_Offset.left = -16;
			m_Icon = theApp.LoadIcon(IDI_UPPERRIGHT);
			m_HotSpot[1].x = -16;
			m_HotSpot[1].y = 0;
			break;
		case BOTTOMLEFT:
			m_Offset.left = m_Offset.bottom = 0;
			m_Offset.top = -16;
			m_Offset.right = 16;
			m_Icon = theApp.LoadIcon(IDI_LOWERLEFT);
			m_HotSpot[1].x = 0;
			m_HotSpot[1].y = -16;
			break;
		case BOTTOMRIGHT:
			m_Offset.left = m_Offset.top = -16;
			m_Offset.bottom = m_Offset.right = 0;
			m_Icon = theApp.LoadIcon(IDI_LOWERRIGHT);
			m_HotSpot[1].x = m_HotSpot[1].y = -16;
			break;
	}
	AdjustAOI(X,Y);
}

void CDestCorner::DrawIcon(CDC *pDC) {pDC->DrawIcon(m_HotSpot[0], m_Icon);}

void CDestCorner::AdjustAOI(int X, int Y) {
	x = X;
	y = Y;
	m_AOI.SetRect(X + m_Offset.left, Y + m_Offset.top, X + m_Offset.right,
		Y + m_Offset.bottom);
	m_HotSpot[0] = m_AOI.TopLeft();
	m_HotSpot[0] += m_HotSpot[1];
}

void CDestCorner::AdjustAOI(CPoint *HotSpot, CPoint *Offset) {
	AdjustAOI(HotSpot->x + Offset->x, HotSpot->y + Offset->y);
}
