/*******************************************************************************
  File: E2A.h
  Developed for Project: Amber, Fare Evaluator
  Proprietary & Confidential Unauthorized Disclosure strictly prohibited
  Copyright (c) 1999 Atraxis AG
  All Rights Reserved.

//$----------------------------------------------------------------------------|
$Header: /osahome/Amber/RWE/libprjs/util/E2A.h,v 1.2 2001/06/12 13:03:41 osaadmin Exp $
  Author: Jack W. Reeves

//!----------------------------------------------------------------------------|
Description:
  An EBCDIC to/from ASCII converter.

//%****************************************************************************************/
#ifndef UTIL_E2A_H
#define UTIL_E2A_H

// Platform header
#include <platform.h>

// Standard C++ headers
#include <functional>

namespace Util {

//
// EBCDIC <-> ASCII conversion
//
struct EBCDIC2ASCII : std::unary_function<char, char> {
	static const char e2a[256];
	char operator()(char c) const {
		return e2a[static_cast<unsigned char>(c)];
	}
};

struct ASCII2EBCDIC : std::unary_function<char, char> {
	static const char a2e[256];
	char operator()(char c) const {
		return a2e[static_cast<unsigned char>(c)];
	}
};

} //> namespace Util

#endif
