// Source.cpp : implementation file
//

#include "stdafx.h"
#include "newtrick.h"
#include "Source.h"
#include "image.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSourceBitmapControl dialog

CSourceBitmapControl::CSourceBitmapControl(CWnd* pParent /*=NULL*/)  // ) {
		: CDialog(CSourceBitmapControl::IDD, pParent) {
	//{{AFX_DATA_INIT(CSourceBitmapControl)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_Bitmap = 0;
	m_Parent = pParent;
	Create(CSourceBitmapControl::IDD, pParent);
}

CSourceBitmapControl::~CSourceBitmapControl() {
	if (m_Bitmap) delete m_Bitmap;
	m_Bitmap = 0;
}

void CSourceBitmapControl::DoDataExchange(CDataExchange* pDX) {
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSourceBitmapControl)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSourceBitmapControl, CDialog)
	//{{AFX_MSG_MAP(CSourceBitmapControl)
	ON_WM_SIZE()
	ON_WM_PAINT()
	ON_WM_VSCROLL()
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSourceBitmapControl message handlers

/////////////////////////////////////////////////////////////////////////////
// CSourceBitmapParent

CSourceBitmapParent::CSourceBitmapParent(){}
CSourceBitmapParent::~CSourceBitmapParent(){}

BEGIN_MESSAGE_MAP(CSourceBitmapParent, CStatic)
	//{{AFX_MSG_MAP(CSourceBitmapParent)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSourceBitmapParent message handlers

void CSourceBitmapParent::OnSize(UINT nType, int cx, int cy) {
	CStatic::OnSize(nType, cx, cy);
	if (m_Child) m_ChildDlgSize.OnSize(nType, cx, cy);
}

CSourceBitmapParent::SetChild(CSourceBitmapControl *In) {
	m_Child = In;
	m_ChildDlgSize.OnInitDialog(this, In);
}

void CSourceBitmapControl::OnSize(UINT nType, int cx, int cy) {
	CDialog::OnSize(nType, cx, cy);
	if (!m_Bitmap) return;
	if (!m_Bitmap->BMPLoaded()) return;
	CSize *s = *m_Bitmap;
	if (!s) return;
	int x = s->cx - cx;
	int y = s->cy - cy;
	if (x < 1) ShowScrollBar(SB_HORZ, FALSE);
	else {
		ShowScrollBar(SB_HORZ, TRUE);
		SetScrollRange(SB_HORZ, 0, x);
	}
	if (y < 1) ShowScrollBar(SB_VERT, FALSE);
	else {
		ShowScrollBar(SB_VERT, TRUE);
		SetScrollRange(SB_VERT, 0, y);
	}
}

BOOL CSourceBitmapControl::LoadBitmap() {
	CFileDialog d(TRUE, ".bmp", 0, 0, "Bitmap Files (*.bmp)|*.bmp||");

	if (d.DoModal() != IDOK) return FALSE;
	if (m_Bitmap) delete m_Bitmap;
	m_Bitmap = new CImageBitmap;
	if (!m_Bitmap->LoadBMPFile(d.GetPathName())) return FALSE;
	CRect r;
	m_Parent->GetClientRect(r);
	SetWindowPos(0, 0, 0, r.Width(), r.Height(), SWP_NOMOVE | SWP_NOZORDER);
	return TRUE;
}

void CSourceBitmapControl::OnPaint() {
	CPaintDC dc(this); // device context for painting
	if (!m_Bitmap) return;
	if (!m_Bitmap->BMPLoaded()) return;
	if (m_Bitmap->CreationRequired()) {
		if (!m_Bitmap->CreateFromBMPFile(&dc)) return;
	}
	CSize *s = *m_Bitmap;
	if (!s) return;
	CDC d;
	d.CreateCompatibleDC(&dc);
	CBitmap *b = d.SelectObject(m_Bitmap);
	CRect r;
	GetClientRect(r);
	int cx = min(s->cx, r.Width());
	int cy = min(s->cy, r.Height());
	int x = max(GetScrollPos(SB_HORZ), 0);
	int y = max(GetScrollPos(SB_VERT), 0);
	dc.BitBlt(0, 0, cx, cy, &d, x, y, SRCCOPY);
	d.SelectObject(b);
}

void CSourceBitmapControl::OnVScroll(UINT nSBCode, UINT nPos,   // ) {
		CScrollBar* pScrollBar) {
	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
	if (nSBCode != SB_THUMBTRACK) return;
	SetScrollPos(SB_VERT, nPos);
	Invalidate();
}

void CSourceBitmapControl::OnHScroll(UINT nSBCode, UINT nPos,   // ) {
		CScrollBar* pScrollBar) {
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
	if (nSBCode != SB_THUMBTRACK) return;
	SetScrollPos(SB_HORZ, nPos);
	Invalidate();
}
