#ifndef WNDSZPOS_H
#define WNDSZPOS_H

#include "classext.h"

// this guy resizes a control to it's parent window

class dbWndSize : public CObject
{
public:
	dbWndSize() {m_Wnd = 0;};
	virtual ~dbWndSize() {};
	void OnInitDialog(CWnd *Parent, CWnd *Control);
	void OnInitDialog(CDialog *Parent, CWnd *Control);
	void OnSize(UINT nType, int cx, int cy);
private:
	CWnd *m_Wnd;
	CPoint m_TopLeft;
	CPoint m_BottomRight;
};

// this guy moves a control as it's parent window changes size
// Min x/y are point where we stop moving this guy if the window get's
// any smaller than this (top left corner of control)

class dbWndPosition : public CObject
{
public:
	dbWndPosition() {m_Wnd = 0;};
	virtual ~dbWndPosition() {};
	void OnInitDialog(CWnd *Parent, CWnd *Control, int Minx = 10, int Miny = 10);
	void OnSize(UINT nType, int cx, int cy);
private:
	CWnd *m_Wnd;
	CPoint m_TopLeft;
	CPoint m_BottomRight;
	int m_MinX;
	int m_MinY;
};

// this guy let's you resize a dialog as you remove controls

class dbDlgSize : public CObject
{
public:
	dbDlgSize() {};
	virtual ~dbDlgSize() {};
	void SetBottom(CDialog *Dialog, CWnd *Original, CWnd *New);
	void SetRight(CDialog *Dialog, CWnd *Original, CWnd *New);
};

// this guy sets a horizontal row of controls that move and resize

class dbDlgRowCntrl;

class dbDlgRow : public CObject
{
public:
	dbDlgRow() {m_Valid = FALSE; m_Resizeable.SetAutoDelete(FALSE);};
	virtual ~dbDlgRow() {};
	// call this first to set up parent
	void OnInitDialog(CDialog *Parent, int MinXSpacing = 10); // call 1st
	// call either of these next two for each control 
	void OnInitDialog(CWnd *Control) {OnInitDialog(Control, -1, -1);};
	void OnInitDialog(CWnd *Control, int Min, int Max); // resizable width
	// call either of these last
	void OnInitDialog(int MinYPos, int MinXSize = -1); // floats
	void OnInitDialog(); // ties buttons to bottom of parent
	// call this from Parents OnSize();
	void OnSize(UINT nType, int cx, int cy);
protected:
	DBCOBARRAY<dbDlgRowCntrl> m_Controls;	
	DBCOBARRAY<dbDlgRowCntrl> m_Resizeable;	
	int m_MinXSpacing;
	int m_MinXSize;
	int m_MinYPos;
	BOOL m_Valid;
	CDialog *m_Parent;
	CPoint m_TopLeft;
	CPoint m_BottomRight;
	int m_LastWidth;
	int m_LastSpacing;
	int m_FixedWidth;
	int m_BottomSpacing;
	void Resize(int Delta, int Spacing);
};

#endif
