// glrotateDlg.h : header file
//
// Author  : S. Qureshi
// Created : May, 2001
//
// COPYRIGHT 2001 
// This source code may be used and modified without restriction 
// as long as the copyright and author data remains intact.

#include <vector>
#include <gl/gl.h>
#include <gl/glu.h>
#include <gl/glaux.h>

#if !defined(AFX_GLROTATEDLG_H__23F7E308_4417_11D5_9C11_00500462FEA1__INCLUDED_)
#define AFX_GLROTATEDLG_H__23F7E308_4417_11D5_9C11_00500462FEA1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CGlrotateDlg dialog

class CGlrotateDlg : public CDialog
{
// Construction
public:
	CGlrotateDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CGlrotateDlg)
	enum { IDD = IDD_GLROTATE_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGlrotateDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CGlrotateDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnLoadBmpImage();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnExit();
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnHelp();
	afx_msg void OnSaveBmp();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:

  BOOL SetWindowPixelFormat(HDC hDC);

  BOOL CreateViewGLContext(HDC hDC);

  /** @note resizes dialog according to dimensions of image */
  void ResizeDialog();

  /** @note sets up viewing geometry & creates texture map */ 
  void InitOpenGL();

  /** @note redraw function, commonly refered to as 'display()' the the redbook */
  void RedrawScene();

  /** @note saves image in BMP format */
  void WriteBmpFile(CString &imagePathname, GLubyte *pImageData);

  /** @note OpenGL texture maps must be a power of 2 */
  void TexMapScalePow2();

  /** @note rendering context handle */
  HGLRC m_hGLContext;

  int m_iGLPixelIndex;

  /** @note pointer to (original) image data */
  AUX_RGBImageRec *m_pImageRGB;

  /** @note OpenGL uses this to reference the texture map */
  GLuint m_iTexName;

  /** @note image width */
  GLfloat m_fImageWidth;

  /** @note image height */
  GLfloat m_fImageHeight;

  /** @note OpenGL uses this to reference the display list */
  GLuint m_iDisplayListId;

  /** @note angle of rotation (degrees) */
  GLfloat m_fTheta;

  // after image is read, it shall be put into this structure
  typedef struct {
    std::vector<GLubyte> data;
    int width, height;
  } Image;

  /** @note defines an image */
  Image m_image;

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GLROTATEDLG_H__23F7E308_4417_11D5_9C11_00500462FEA1__INCLUDED_)
